# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from dccomms_ros_msgs/AddCustomDeviceRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AddCustomDeviceRequest(genpy.Message):
  _md5sum = "b491bc38998f4cbf8fcbf6b71c418ed2"
  _type = "dccomms_ros_msgs/AddCustomDeviceRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """string dccommsId
uint32 mac
string frameId
uint32 maxTxFifoSize

#bps
float64 bitrate

#milliseconds
float64 txJitter
float64 rxJitter

#intrinsic delay in ms
float64 intrinsicDelay

#meters
float64 maxDistance
float64 minDistance

#Error rate: 0.0 - 1.0 (Not used)
float64 minPktErrorRate
float64 pktErrorRateIncPerMeter

#Rate Error Model (ns3) (rate in [0.0 - 1.0]:
string errorRateExpr
string errorUnit

#logging
string logLevel

#Mac protocol: broadcast MAC ; T-MAC ; FAMA ; Slotted-FAMA ; UWAN-MAC ; COPE-MAC ; ALOHA ; R-MAC ; GOAL
string macProtocol
float64 macDistance
uint32 maxBackoffSlots
"""
  __slots__ = ['dccommsId','mac','frameId','maxTxFifoSize','bitrate','txJitter','rxJitter','intrinsicDelay','maxDistance','minDistance','minPktErrorRate','pktErrorRateIncPerMeter','errorRateExpr','errorUnit','logLevel','macProtocol','macDistance','maxBackoffSlots']
  _slot_types = ['string','uint32','string','uint32','float64','float64','float64','float64','float64','float64','float64','float64','string','string','string','string','float64','uint32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       dccommsId,mac,frameId,maxTxFifoSize,bitrate,txJitter,rxJitter,intrinsicDelay,maxDistance,minDistance,minPktErrorRate,pktErrorRateIncPerMeter,errorRateExpr,errorUnit,logLevel,macProtocol,macDistance,maxBackoffSlots

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddCustomDeviceRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.dccommsId is None:
        self.dccommsId = ''
      if self.mac is None:
        self.mac = 0
      if self.frameId is None:
        self.frameId = ''
      if self.maxTxFifoSize is None:
        self.maxTxFifoSize = 0
      if self.bitrate is None:
        self.bitrate = 0.
      if self.txJitter is None:
        self.txJitter = 0.
      if self.rxJitter is None:
        self.rxJitter = 0.
      if self.intrinsicDelay is None:
        self.intrinsicDelay = 0.
      if self.maxDistance is None:
        self.maxDistance = 0.
      if self.minDistance is None:
        self.minDistance = 0.
      if self.minPktErrorRate is None:
        self.minPktErrorRate = 0.
      if self.pktErrorRateIncPerMeter is None:
        self.pktErrorRateIncPerMeter = 0.
      if self.errorRateExpr is None:
        self.errorRateExpr = ''
      if self.errorUnit is None:
        self.errorUnit = ''
      if self.logLevel is None:
        self.logLevel = ''
      if self.macProtocol is None:
        self.macProtocol = ''
      if self.macDistance is None:
        self.macDistance = 0.
      if self.maxBackoffSlots is None:
        self.maxBackoffSlots = 0
    else:
      self.dccommsId = ''
      self.mac = 0
      self.frameId = ''
      self.maxTxFifoSize = 0
      self.bitrate = 0.
      self.txJitter = 0.
      self.rxJitter = 0.
      self.intrinsicDelay = 0.
      self.maxDistance = 0.
      self.minDistance = 0.
      self.minPktErrorRate = 0.
      self.pktErrorRateIncPerMeter = 0.
      self.errorRateExpr = ''
      self.errorUnit = ''
      self.logLevel = ''
      self.macProtocol = ''
      self.macDistance = 0.
      self.maxBackoffSlots = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.dccommsId
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.mac
      buff.write(_get_struct_I().pack(_x))
      _x = self.frameId
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_I8d().pack(_x.maxTxFifoSize, _x.bitrate, _x.txJitter, _x.rxJitter, _x.intrinsicDelay, _x.maxDistance, _x.minDistance, _x.minPktErrorRate, _x.pktErrorRateIncPerMeter))
      _x = self.errorRateExpr
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.errorUnit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.logLevel
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.macProtocol
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_dI().pack(_x.macDistance, _x.maxBackoffSlots))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dccommsId = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dccommsId = str[start:end]
      start = end
      end += 4
      (self.mac,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frameId = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frameId = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.maxTxFifoSize, _x.bitrate, _x.txJitter, _x.rxJitter, _x.intrinsicDelay, _x.maxDistance, _x.minDistance, _x.minPktErrorRate, _x.pktErrorRateIncPerMeter,) = _get_struct_I8d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.errorRateExpr = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.errorRateExpr = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.errorUnit = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.errorUnit = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.logLevel = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.logLevel = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.macProtocol = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.macProtocol = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.macDistance, _x.maxBackoffSlots,) = _get_struct_dI().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.dccommsId
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.mac
      buff.write(_get_struct_I().pack(_x))
      _x = self.frameId
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_I8d().pack(_x.maxTxFifoSize, _x.bitrate, _x.txJitter, _x.rxJitter, _x.intrinsicDelay, _x.maxDistance, _x.minDistance, _x.minPktErrorRate, _x.pktErrorRateIncPerMeter))
      _x = self.errorRateExpr
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.errorUnit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.logLevel
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.macProtocol
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_dI().pack(_x.macDistance, _x.maxBackoffSlots))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.dccommsId = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.dccommsId = str[start:end]
      start = end
      end += 4
      (self.mac,) = _get_struct_I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.frameId = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.frameId = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.maxTxFifoSize, _x.bitrate, _x.txJitter, _x.rxJitter, _x.intrinsicDelay, _x.maxDistance, _x.minDistance, _x.minPktErrorRate, _x.pktErrorRateIncPerMeter,) = _get_struct_I8d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.errorRateExpr = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.errorRateExpr = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.errorUnit = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.errorUnit = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.logLevel = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.logLevel = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.macProtocol = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.macProtocol = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.macDistance, _x.maxBackoffSlots,) = _get_struct_dI().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_I8d = None
def _get_struct_I8d():
    global _struct_I8d
    if _struct_I8d is None:
        _struct_I8d = struct.Struct("<I8d")
    return _struct_I8d
_struct_dI = None
def _get_struct_dI():
    global _struct_dI
    if _struct_dI is None:
        _struct_dI = struct.Struct("<dI")
    return _struct_dI
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from dccomms_ros_msgs/AddCustomDeviceResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class AddCustomDeviceResponse(genpy.Message):
  _md5sum = "e27848a10f8e7e4030443887dfea101b"
  _type = "dccomms_ros_msgs/AddCustomDeviceResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """bool res

"""
  __slots__ = ['res']
  _slot_types = ['bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       res

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(AddCustomDeviceResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.res is None:
        self.res = False
    else:
      self.res = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.res
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.res,) = _get_struct_B().unpack(str[start:end])
      self.res = bool(self.res)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.res
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 1
      (self.res,) = _get_struct_B().unpack(str[start:end])
      self.res = bool(self.res)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
class AddCustomDevice(object):
  _type          = 'dccomms_ros_msgs/AddCustomDevice'
  _md5sum = '7e2af6af0b0decc972614180f27f0812'
  _request_class  = AddCustomDeviceRequest
  _response_class = AddCustomDeviceResponse
